package CGIN;       #transparent
use strict;
use CGI;

our $VERSION = "1.3";

sub convert
{
  my  $x ;

  $x=$_[0] ;
  $x =~ s/\+/ /g ;
  $x =~ s/%(..)/pack("c",hex($1))/ge;
  $x ;
}

sub get_name_value_pairs
{
  my ( @input, $pair, $name, $value ) ;
  my $value_by_name={};

  if ( defined $ENV{'CONTENT_LENGTH'} )
  {
    read STDIN, $_, $ENV{'CONTENT_LENGTH'} ;

    @input=split /&/ ;

    while ( $pair = shift @input )
    {
      ($name, $value ) = split /=/, $pair ;
      push(@{$value_by_name->{convert($name)}},convert($value));
    }
  }
  else
  {
    @input=split( /&/,$ENV{'QUERY_STRING'});

    while ( $pair = shift @input )
    {
      ( $name, $value ) = split /=/, $pair ;
      push(@{$value_by_name->{$name}},$value);
    }
  }
  return($value_by_name);
}

sub uri_escape
{
  my $x ;

  $x=$_[0] ;
  $x =~ s/([^ \w])/sprintf("%%%02X",ord($1))/ge;
  $x =~ s/ /\+/g ;
  $x ;
}

sub new
{
  my $self  = new CGI;

  foreach my $par (@{$self->{'.parameters'}})
  {
    $self->{$par} = $self->{'param'}->{$par};
  }

  return($self);
}

'end CGIN';       #transparent
